Index: /pjproject/trunk/pjnath/include/pjnath/turn_session.h
===================================================================
--- /pjproject/trunk/pjnath/include/pjnath/turn_session.h	(revision 2641)
+++ /pjproject/trunk/pjnath/include/pjnath/turn_session.h	(revision 2642)
@@ -31,23 +31,97 @@
 PJ_BEGIN_DECL
 
-/**
- * @defgroup PJNATH_TURN TURN Client Library
- */
-
 
 /* **************************************************************************/
 /**
- * @defgroup PJNATH_TURN_SESSION Transport independent TURN client session
- * @brief Transport independent TURN client session
- * @ingroup PJNATH_TURN
- * @{
- *
- * This module describes the transport independent TURN client session. This
- * interface is provided for implementors of a TURN client transport, and
- * application usually will want to use \ref PJNATH_TURN_SOCK instead.
- *
- * The transport independent TURN client session is created to facilitate
- * the creation of different types of transports between the client and the
- * TURN server.
+@addtogroup PJNATH_TURN_SESSION
+@{
+
+The \ref PJNATH_TURN_SESSION is a transport-independent object to
+manage a client TURN session. It contains the core logic for manage
+the TURN client session as listed in \ref turn_op_sec, but
+in transport-independent manner (i.e. it doesn't have a socket), so
+that developer can integrate TURN client functionality into existing
+framework that already has its own means to send and receive data,
+or to support new transport types to TURN, such as TLS.
+
+
+\section turn_sess_using_sec Using the TURN session
+
+These steps describes how to use the TURN session:
+
+ - <b>Creating the session</b>:\n
+   use #pj_turn_session_create() to create the session. 
+
+ - <b>Configuring credential</b>:\n
+   all TURN operations requires the use of authentication (it uses STUN 
+   long term autentication method). Use #pj_turn_session_set_credential()
+   to configure the TURN credential to be used by the session.
+
+ - <b>Configuring server</b>:\n
+   application must call #pj_turn_session_set_server() before it can send
+   Allocate request (with pj_turn_session_alloc()). This function will
+   resolve the TURN server using DNS SRV resolution if the \a resolver
+   is set. The server resolution process will complete asynchronously,
+   and application will be notified in \a on_state() callback of the 
+   #pj_turn_session_cb structurewith the session state set to 
+   PJ_TURN_STATE_RESOLVED.
+
+ - <b>Creating allocation</b>:\n
+   create one "relay port" (or called <b>relayed-transport-address</b>
+   in TURN terminology) in the TURN server by using #pj_turn_session_alloc().
+   This will send Allocate request to the server. This function will complete
+   immediately, and application will be notified about the allocation
+   result in the \a on_state() callback of the #pj_turn_session_cb structure.
+
+ - <b>Getting the allocation result</b>:\n
+   if allocation is successful, the session state will progress to
+   \a PJ_TURN_STATE_READY, otherwise the state will be 
+   \a PJ_TURN_STATE_DEALLOCATED or higher. Session state progression is
+   reported in the \a on_state() callback of the #pj_turn_session_cb 
+   structure. On successful allocation, application may retrieve the
+   allocation info by calling #pj_turn_session_get_info().
+
+ - <b>Sending data through the relay</b>.\n
+   Once allocation has been created, client may send data to any remote 
+   endpoints (called peers in TURN terminology) via the "relay port". It does
+   so by calling #pj_turn_session_sendto(), giving the peer address 
+   in the function argument. But note that at this point peers are not allowed
+   to send data towards the client (via the "relay port") before permission is
+   installed for that peer.
+
+ - <b>Creating permissions</b>.\n
+   Permission needs to be created in the TURN server so that a peer can send 
+   data to the client via the relay port (a peer in this case is identified by
+   its IP address). Without this, when the TURN server receives data from the
+   peer in the "relay port", it will drop this data. Create the permission by
+   calling #pj_turn_session_set_perm(), specifying the peer IP address in the
+   argument (the port part of the address is ignored). More than one IP 
+   addresses may be specified.
+
+ - <b>Receiving data from peers</b>.\n
+   Once permission has been installed for the peer, any data received by the 
+   TURN server (from that peer) in the "relay port" will be relayed back to 
+   client by the server, and application will be notified via \a on_rx_data
+   callback of the #pj_turn_session_cb.
+
+ - <b>Using ChannelData</b>.\n
+   TURN provides optimized framing to the data by using ChannelData 
+   packetization. The client activates this format for the specified peer by
+   calling #pj_turn_session_bind_channel(). Data sent or received to/for
+   this peer will then use ChannelData format instead of Send or Data 
+   Indications.
+
+ - <b>Refreshing the allocation, permissions, and channel bindings</b>.\n
+   Allocations, permissions, and channel bindings will be refreshed by the
+   session automatically when they about to expire.
+
+ - <b>Destroying the allocation</b>.\n
+   Once the "relay port" is no longer needed, client destroys the allocation
+   by calling #pj_turn_session_shutdown(). This function will return
+   immediately, and application will be notified about the deallocation
+   result in the \a on_state() callback of the #pj_turn_session_cb structure.
+   Once the state has reached PJ_TURN_STATE_DESTROYING, application must
+   assume that the session will be destroyed shortly after.
+
  */
 
Index: /pjproject/trunk/pjnath/include/pjnath/turn_sock.h
===================================================================
--- /pjproject/trunk/pjnath/include/pjnath/turn_sock.h	(revision 2641)
+++ /pjproject/trunk/pjnath/include/pjnath/turn_sock.h	(revision 2642)
@@ -33,15 +33,24 @@
 /* **************************************************************************/
 /**
- * @defgroup PJNATH_TURN_SOCK TURN client transport
- * @brief Client transport utilizing TURN relay
- * @ingroup PJNATH_TURN
- * @{
- *
- * The TURN relay client transport can be used to relay data from the client
- * to peer via a TURN relay. The application establishes TURN connection to
- * the TURN server using UDP or TCP as the transport, then creates a relay
- * address in the TURN server to be advertised to remote peer(s) as the 
- * transport address. When application sends data to a remote address via
- * this transport, the data will be sent via the TURN relay, and vice versa.
+@addtogroup PJNATH_TURN_SOCK
+@{
+
+This is a ready to use object for relaying application data via a TURN server,
+by managing all the operations in \ref turn_op_sec.
+
+\section turnsock_using_sec Using TURN transport
+
+This object provides a thin wrapper to the \ref PJNATH_TURN_SESSION, hence the
+API is very much the same (apart from the obvious difference in the names).
+Please see \ref PJNATH_TURN_SESSION for the documentation on how to use the
+session.
+
+\section turnsock_samples_sec Samples
+
+The \ref turn_client_sample is a sample application to use the
+\ref PJNATH_TURN_SOCK.
+
+Also see <b>\ref samples_page</b> for other samples.
+
  */
 
@@ -207,4 +216,19 @@
 
 /**
+ * Configure the SOFTWARE name to be sent in all STUN requests by the
+ * TURN session.
+ *
+ * @param turn_sock	The TURN transport instance.
+ * @param sw	    Software name string. If this argument is NULL or
+ *		    empty, the session will not include SOFTWARE attribute
+ *		    in STUN requests and responses.
+ *
+ * @return	    PJ_SUCCESS on success, or the appropriate error code.
+ */
+PJ_DECL(pj_status_t) pj_turn_sock_set_software_name(pj_turn_sock *turn_sock,
+						    const pj_str_t *sw);
+
+
+/**
  * Allocate a relay address/resource in the TURN server. This function
  * will resolve the TURN server using DNS SRV (if desired) and send TURN
Index: /pjproject/trunk/pjnath/include/pjnath/types.h
===================================================================
--- /pjproject/trunk/pjnath/include/pjnath/types.h	(revision 2641)
+++ /pjproject/trunk/pjnath/include/pjnath/types.h	(revision 2642)
@@ -73,229 +73,4 @@
  */
 
-/* Doxygen documentation below: */
-
-/**
-
-@mainpage PJNATH - Open Source ICE, STUN, and TURN Library
-
-\n
-This is the documentation of PJNATH, an Open Source library providing
-NAT traversal helper functionalities by using standard based protocols
-such as STUN, TURN, and ICE.
-
-\n
-\n
-
-\section lib_comps Library Components
-
-\subsection comp_stun STUN
-
-Session Traversal Utilities (STUN, or previously known as Simple 
-Traversal of User Datagram Protocol (UDP) Through Network Address 
-Translators (NAT)s), is a lightweight protocol that serves as a tool for
-application protocols in dealing with NAT traversal. It allows a client
-to determine the IP address and port allocated to them by a NAT and to 
-keep NAT bindings open.
-
-This version of PJNATH implements the following STUN RFC:
-- <A HREF="http://www.ietf.org/rfc/rfc5389.txt"><B>RFC 5389</b></A>: 
-    Session Traversal Utilities for (NAT) (STUN),
-
-
-\subsection comp_turn TURN
-
-Traversal Using Relays around NAT (TURN) allows the host to control the
-operation of the relay and to exchange packets with its peers using the relay.
-
-Features:
- - <A HREF="http://www.ietf.org/internet-drafts/draft-ietf-behave-turn-13.txt">
-   <B>draft-ietf-behave-turn-13</B></A>: Obtaining Relay Addresses 
-   from Simple Traversal Underneath NAT (STUN)
- - DNS SRV resolution
- - Fallback to DNS A resolution if SRV record is not found
- - UDP and TCP connection to TURN server
- - automatic management of allocation refresh
-
-
-
-\subsection comp_ice ICE
-
-Interactive Connectivity Establishment (ICE) is a standard based 
-methodology for traversing Network Address Translator (NAT). This
-implementation is aimed to provide a usable and generic ICE transports
-for different types of application, including but not limited to
-the usage of ICE in SIP/SDP offer/answer.
-
-
-This version of PJNATH implements the following ICE draft:
- - <A HREF="http://www.ietf.org/internet-drafts/draft-ietf-mmusic-ice-19.txt">
-   <B>draft-ietf-mmusic-ice-19.txt</B></A> draft. The PJNATH ICE
-
-
-\subsection comp_natck NAT Classification Utility
-
-The PJNATH library also provides NAT classification utility as 
-described in <A HREF="http://www.ietf.org/rfc/rfc3489.txt">RFC 3489</A>.
-While the practice to detect the NAT type to assist NAT traversal
-has been deprecated in favor of ICE, the information may still be
-useful for troubleshooting purposes, hence the utility is provided.
-
-
-\n
-\n
-
-\section lib_org Library Organization
-
-The PJNATH library consists of many components with each providing
-specific functionality that may or may not be of the interests of 
-applications (or application developers). This section attempts to 
-give brief overview on the components provided by PJNATH.
-
-The PJNATH components from the highest layer to the lower layer are
-as follows.
-
-
-\n
-
-\subsection user_comp High-level Transport Objects
-
-PJNATH library provides some high-level objects that may be used
-by applications:
-
-
-\subsubsection stun_sock STUN Transport
-
-The \ref PJNATH_STUN_SOCK provides asynchronous UDP like socket transport
-with the additional capability to query the publicly mapped transport
-address (using STUN resolution), to refresh the NAT binding, and to
-demultiplex internal STUN messages from application data (the 
-application data may be a STUN message as well).
-
-
-\subsubsection turn_sock TURN Client Transport
-
-The \ref PJNATH_TURN_SOCK may be used by the application to send and
-receive data via TURN server. For more information please see the
-documentation of \ref PJNATH_TURN_SOCK.
-
-
-\subsubsection ice_strans ICE Stream Transport
-
-The \ref PJNATH_ICE_STREAM_TRANSPORT provides transport interface to
-send and receive data through connection that is negotiated
-with ICE protocol. The \ref PJNATH_ICE_STREAM_TRANSPORT naturally 
-contains both STUN Transport and \ref PJNATH_TURN_SOCK.
-
-The \ref PJNATH_ICE_STREAM_TRANSPORT interface is suitable for both
-SIP or non-SIP use. For SIP use, application may prefer to use the
-ICE media transport in PJMEDIA instead where it has been integrated
-with the SDP offer and answer mechanism.
-
-
-\subsubsection natck NAT Classification Utility
-
-PJNATH also provides \a PJNATH_NAT_DETECT to assist troubleshooting
-of problems related to NAT traversal.
-
-
-
-\n
-
-
-\subsection sessions Transport Independent Sessions Layer
-
-Right below the high level transports objects are the transport
-independent sessions. These sessions don't have access to sockets,
-so higher level objects (such as transports) must give incoming
-packets to the sessions and provide callback to be called by
-sessions to send outgoing packets.
-
-
-\subsubsection ice_sess ICE Session
-
-The \ref PJNATH_ICE_SESSION is used by the \ref PJNATH_ICE_STREAM_TRANSPORT
-and contains the actual logic of the ICE negotiation.
-
-
-\subsubsection turn_sess TURN Session
-
-The \ref PJNATH_TURN_SESSION is used by the \ref PJNATH_TURN_SOCK
-and it contains TURN protocol logic. Implementors may implement
-other types of TURN client connection (such as TURN TLS client)
-by utilizing this session.
-
-
-\subsubsection stun_sess STUN Session
-
-The \ref PJNATH_STUN_SESSION manages STUN message exchange between
-a client and server (or vice versa). It manages \ref PJNATH_STUN_TRANSACTION
-for sending or receiving requests and \ref PJNATH_STUN_AUTH for both
-both incoming and outgoing STUN messages. 
-
-The \ref PJNATH_STUN_SESSION is naturally used by the \ref PJNATH_TURN_SESSION
-and \ref PJNATH_ICE_SESSION
-
-
-\n
-
-\subsection stun_tsx STUN Transaction Layer
-
-The \ref PJNATH_STUN_TRANSACTION is a thin layer to manage retransmission
-of STUN requests.
-
-
-\n
-
-
-\subsection stun_msg STUN Messaging Layer
-
-At the very bottom of the PJNATH components is the \ref PJNATH_STUN_MSG
-layer. The API contains various representation of STUN messaging components
-and it provides API to encode and decode STUN messages.
-
-
-
-\n
-\n
-
-\section class_dia Class Diagram
-
-
-The following class diagram shows the interactions between objects in
-PJNATH:
-
-\image html UML-class-diagram.png "Class Diagram"
-\image latex UML-class-diagram.png "Class Diagram"
-
-
-
-\n
-\n
-
-\section samples Sample Applications
-
-
-Some sample applications have been provided with PJNATH, and it's available
-under <tt>pjnath/src</tt> directory:
-
-   - <b>pjturn-client</b>: this is a stand-alone, console based TURN client
-     application to be used as a demonstration for PJNATH TURN client 
-     transport API and for simple testing against TURN server implementations.
-     The client supports both UDP and TCP connection to the TURN server.
-
-   - <b>pjturn-srv</b>: this is a simple TURN server to be used for testing
-     purposes. It supports both UDP and TCP connections to the clients.
-
-
-*/
-
-/**
- * @defgroup PJNATH_STUN STUN Library
- * @brief Open source STUN library
- *
- * This module contains implementation of STUN library in PJNATH -
- * the open source NAT helper containing STUN and ICE.
- */
-
 #endif	/* __PJNATH_TYPES_H__ */
 
Index: /pjproject/trunk/pjnath/src/pjnath/turn_sock.c
===================================================================
--- /pjproject/trunk/pjnath/src/pjnath/turn_sock.c	(revision 2641)
+++ /pjproject/trunk/pjnath/src/pjnath/turn_sock.c	(revision 2642)
@@ -340,4 +340,13 @@
 
 /*
+ * Set software name
+ */
+PJ_DEF(pj_status_t) pj_turn_sock_set_software_name( pj_turn_sock *turn_sock,
+						    const pj_str_t *sw)
+{
+    return pj_turn_session_set_software_name(turn_sock->sess, sw);
+}
+
+/*
  * Initialize.
  */
